# News Categories ][
# by plushpuffin
# email: plushpuffin@wwddfd.com
# http://www.wwddfd.com
#
$nc2Build = 12;
&CheckBuild( 29, "NewsCat ][ build $nc2Build", 'npa_newscat2.pl' );
push(@Addons_Loaded, qq~News Categories ][ build $nc2Build~);
push(@Addons_DisplaySubForm, 'NewsCatSubForm');
push(@Addons_PageHandler, 'NewsCatPageHandler');
push(@Addons_BuildNews_Post, 'NewsCatBuild');
push(@Addons_MainPage, 'NewsCat_MainPage');
push(@Addons_NPHTMLFoot, 'NewsCat_HTMLFoot');
push(@Addons_RemoveNews2, 'NewsCatRemoveNews2');
push(@Addons_RemoveNewsSave, 'NewsCatRemoveNewsSave');
push(@Addons_SaveNews_3, 'NewsCatSubmitSaveBuild');
push(@Addons_RemoveNewsSave_2, 'NewsCatRemoveNewsSaveBuild');
$Addons_List{qq~News Categories ][ build $nc2Build~} = ['npa_newscat2.pl',
q~Manages different categories and news files (profiles) from one copy of NewsPro. by <a href="mailto:plushpuffin@wwddfd.com">plushpuffin</a> - <b><a href="http://www.wwddfd.com">perl garden</a></b>~,''];
$FormFieldsName{'newscat'} ||= "News Category";
$FormFieldsName{'newsid'} ||= "News ID";
$FormFieldsName{'newstime'} ||= "News UNIX Time";
$FormFieldsName{'newsrand'} = "News RandPart - Not recommended";
$NC2_ArchiveNumber = $NPConfig{'ArchiveNumber'} || 20;
	
sub NCBuildFields {
#
# Here is where you should define any variables
# you may wish to use when "slicing" by field.
#
# Besides what you have defined in npconfig.pl,
# the following variables are available for use:
#
#---------------------------------------------
#	$Second, $Minute, $Hour, $AMPM
#	$Weekday, $Day
#	$Month, $Month_Number, $Month_Name
#	$Year, $Time_Zone
#
# Variable / Value      Jan     Aug     Dec
#---------------------------------------------
# $Month                00      07      11
# $Month_Number         01      08      12
#---------------------------------------------
#
	$DoubleMonth = $Month_Number < 10 ? "0$Month_Number" : $Month_Number;
	$DoubleDay = $Day < 10 ? "0$Day" : $Day;
	
	$MonthYear = qq~$Month_Name-$Year~;
	$MonthNumYear = qq~$Month_Number-$Year~;
	$arcYearMonthDay = qq~arc-$Year-$DoubleMonth$DoubleDay~;
	$TenPerPage = 'arc' . int(($NewsCounter-1)/10);
	$ArchiveNumberPerPage = 'arc' . int(($NewsCounter-1)/$NC2_ArchiveNumber);
	$FirstLetter = uc substr($newssubject, 0, 1);
}

sub NCLoadFields {
#	Here you should insert the names of the
#	variables you declared in the NCBuildFields
#	subroutine above. After you have inserted them
#	here, you will be able to select them on the
#	"Edit Profile" page in NewsCat ][
#
#	Follow the example below. Use spaces, not commas.
#	To insert a variable called ThisDayOfMonth:
#
#		in NCBuildFields above, put:
#	$ThisDayOfMonth = qq~$Day$Month_Name~;
#
#		NCLoadFields, below, should read:
#	return qw/MonthYear MonthNumYear ThisDayOfMonth/;
#
#
	$FormFieldsName{'MonthYear'} = q~*MonthName-Year~;
	$FormFieldsName{'MonthNumYear'} = q~*MonthNumber-Year~;
	$FormFieldsName{'arcYearMonthDay'} = q~*arc-Year-MonthDay~;
	$FormFieldsName{'TenPerPage'} = q~*Ten news items per page~;
	$FormFieldsName{'ArchiveNumberPerPage'} = qq~*Archive Number: $NC2_ArchiveNumber per page~;
	$FormFieldsName{'FirstLetter'} = q~*First Letter of Subject~;
	return qw/MonthYear MonthNumYear arcYearMonthDay TenPerPage ArchiveNumberPerPage FirstLetter/;
}

sub NewsCatFilter {
	my $mintime = pop;
	$mintime = $mintime * 86400;
	$mintime = time - $mintime;
	my( $i, $nd, @NewNewsData, %filtcats );
	foreach $i (@_) {
		$filtcats{$i} = 1;
	}
	$filtcats{''} = $filtcats{'(default)'};
	delete $filtcats{'(default)'};
	$#NewNewsData = $#NewsData;
	$i = -1;
	foreach $nd (@NewsData) {
		# First, check if it matches the category.
		if ( $filtcats{'AllCategories'} || $filtcats{$nd->{'newscat'}} ) {
			# It matches. Now check the time.
			if ($nd->{'newstime'} >= $mintime && $nd->{'newstime'} <= $NC2_MIN_AGE ) {
				# It's good. Add to the new array.
				++$i;
				$NewNewsData[$i] = $nd;
			}
		}
	}
	$#NewNewsData = $i;
	return @NewNewsData;
}

sub NewsCatFilterReverse {
	return reverse(&NewsCatFilter(@_));
}

sub NewsCatFilterAlpha {
	return	map { $_->[0] }
		sort { $b->[1] cmp $a->[1] }
		map { [ $_, $_->{'newssubject'} ] } &NewsCatFilter(@_);
}

sub DoSliceIndexHTML {
	$newshtml = qq~~;
	$newshtml .= qq~<a href="$baseURL/$LinkURL">$LinkText</a><br>\n~;
}

sub staticlinks {
	$newshtml = qq~~;
	$fname = &NCMakeFName;
	$newshtml .= qq~<a href="$baseURL/$fname">$newssubject</a><BR>~;
}

#	Get the current news item's file name
#	(static page file field must be set for the current profile,
#	even if that profile doesn't do static pages)
sub NCMakeFName
{
	$_ = ${$prof->[13]} || ${'newsid'};
	$_ =~ s~[^\w\-\.]~~g;
	$_ = substr( $_, 0, 24 );
	$_ .= ".$filext";
	return $_;
}

#	Generate file name for the current newsitem,
#	using the name of the field passed in as the
#	file field.
#		eg:	NCGetFName( 'newssubject' )
sub NCGetFName
{
	$_ = shift || 'newsid';
	$_ = ${$_};
	$_ =~ s~[^\w\-\.]~~g;
	$_ = substr( $_, 0, 24 );
	$_ .= ".$filext";
	return $_;
}

#	Generate file name for the current newsitem,
#	using the name of the field passed in as the
#	file field, but WITHOUT the file extension
#		eg:	NCGetPartialFName( 'newssubject' )
sub NCGetPartialFName
{
	$_ = shift || 'newsid';
	$_ = ${$_};
	$_ =~ s~[^\w\-\.]~~g;
	$_ = substr( $_, 0, 24 );
	return $_;
}

#	Generate file name for the current newsitem,
#	using this profile's static page field field.
#	The file extension is NOT generated.
#	(static page file field must be set for the current profile,
#	even if that profile doesn't do static pages)
#		eg:	NCMakePartialFName()
sub NCMakePartialFName
{
	$_ = ${$prof->[13]} || ${'newsid'};
	$_ =~ s~[^\w\-\.]~~g;
	$_ = substr( $_, 0, 24 );
	return $_;
}

sub NewsCatBuild {
	&NewsCatLoadConfig;
	foreach $i (sort keys %newsprofiles) {
		if ($newsprofiles{$i}->[0]) {
			unless($newsprofiles{$i}->[16] && $newsprofiles{$i}->[12] =~ /static/i ) {
				&BuildProfile;
			}
		}
	}
	if( @Addons_NewsCat2_EndBuild ) {
		&RunAddons(@Addons_NewsCat2_EndBuild);
	}
}

sub NewsCatTotalReBuild {
	$newscat2completebuild = 'yes';
	&NewsCatLoadConfig;
	&loadND;
	require $ndisplaypl;
	foreach $i (sort keys %newsprofiles) {
		if ($newsprofiles{$i}->[0]) {
			&BuildProfile;
		}
	}
	if( @Addons_NewsCat2_EndBuild ) {
		&RunAddons(@Addons_NewsCat2_EndBuild);
	}
}

sub NewsCatBuildStatic {
	&NewsCatLoadConfig;
	require $ndisplaypl;
	foreach $i (sort keys %newsprofiles) {
		if ($newsprofiles{$i}->[0] && ( $newsprofiles{$i}->[12] ne '' && $newsprofiles{$i}->[12] !~ /sli/i ) && $newsprofiles{$i}->[16]) {
			&BuildProfile;
		}
	}
	if( @Addons_NewsCat2_EndBuild ) {
		&RunAddons(@Addons_NewsCat2_EndBuild);
	}
}

sub NewsCatSubmitSaveBuild {
	if ($newsktalk) {
		$ktalkURL = $snid;
		$ktalkURL =~ s/[^\d\,]//g;
		$ktalkURL = "$talkbaseurl/$ktalkURL$talkext";
		$ktalknum = 0;
	}
	else {
		$ktalkURL = '';
		$ktalknum = 0;
	}
#
#	BUG FIX HERE
#
	($newstime, $newsrand, $newscat) = split(/,/, $newsid);
#
#	BUG FIX. This is something Lawrence Williams caught but I didn't.
#	When newspro tries to come up with a unique random number, it
#	generates the random continuously in $rando and then sets the
#	$newsid to "time,$rando,$newscat" ...
#
#	I was accidentally allowing the use of "$newsrand" to name
#	the HTML files that NewsCat ][ generates, even though $newsrand
#	is NOT reset to the value it should have when the random number
#	generator ends. It is necessary to split the $newsid into thirds
#	in order to obtain the final value for $newsrand.
#
#
#	Thanks to Korix at http://riftgaming.com for allowing use of his
#	site for debugging purposes.
#
#		-- plushpuffin@wwddfd.com
#		-- September 18, 2000 C.E.
#	
#
	local @NewsData;
	local $newsid = $snid;
	&SubmitFormFields;
	my @ffields = @formfields;
	push(@ffields, @ffield_add);
	foreach (@ffields) {
		$NewsData[0]->{$_} = ${$_};
	}
	&NewsCatBuildStatic;
}

sub NewsCatRemoveNewsSaveBuild {
	&loadND;
	NewsCatRNSB2( \@NewsData );
}

sub NewsCatRNSB2 {
	my $reff = shift;
	my( $key, $val );
	local @NewsData;
	while( ($key,$val) = each(%ChangedItems) ) {
		if( $val ) {
			push( @NewsData, $$reff[$key] );
		}
	}
	&NewsCatBuildStatic;
}

sub BuildProfile {
	my( $ff, $content, $filtsub );
	$prof = $newsprofiles{$i};
	$baseURL = $prof->[17];
	$thisURL = $prof->[20];
	$profile_title = $prof->[7];
	$filext = $prof->[18] || $NPConfig{'ArcHtmlExt'} || 'html';
	# Filter by category and date.
	if ($prof->[8]) {$filtsub = $prof->[8];}
	else {$filtsub = 'NewsCatFilter';}
	$NC2_MIN_AGE = time + (3600 * $NPConfig{'TimeOffset'}) - ( $prof->[19] * 86400 );
	@FilteredND = &$filtsub(split(/\!/, $prof->[2]), $prof->[3]);
	# Filter by maximum number.
	if (@FilteredND > $prof->[4] || $prof->[11]) {
		my $maxnum = $#FilteredND - $prof->[11];
		my $minnum = $maxnum - $prof->[4];
		$minnum++;
		$minnum = $minnum < 0 ? 0 : $minnum;
		@FilteredND = @FilteredND[$minnum..$maxnum];
	}
	# Filtered! Build news.
	$newsnum = $#FilteredND;
	$content = '';
	$FileName = '';
	$FilePrev = '';
	$FileNext = '';
	$FileLast = '';
	$FileFirst = '';
	$NewsCounter = 0;
	$TotalNews = @FilteredND;
	if( $prof->[12] && $prof->[12] =~ /sli/i ) {
		${$prof->[13]} = $FilteredND[0]->{$ff};
		$newsid = $FilteredND[0]->{'newsid'};
		$FileLast = &NCMakeFName;
		${$prof->[13]} = $FilteredND[$#FilteredND]->{$ff};
		$newsid = $FilteredND[$#FilteredND]->{'newsid'};
		$FileFirst = &NCMakeFName;
	}
	if( $prof->[12] eq 'split' ) {
		@statsubs = ();
		push( @statsubs, $prof->[5] ) if( $prof->[5] );
		@stattmpl = ();
		push( @stattmpl, $prof->[6] ) if( $prof->[6] );
		@_ = split( /;*\s*;\s*;*/, $prof->[14] );
		foreach (@_) {
			push( @stattmpl, $_ ) if( $_ );
		}
		@_ = split( /;*\s*;\s*;*/, $prof->[15] );
		foreach (@_) {
			push( @statsubs, $_ ) if( $_ );
		}
		while ($newsnum >= 0) {
			$NewsCounter++;
			if( $newsnum ) {
				${$prof->[13]} = $FilteredND[$newsnum-1]->{$ff};
				$newsid = $FilteredND[$newsnum-1]->{'newsid'};
				$FileNext = &NCMakeFName;
			}
			else {
				$FileNext = '';
			}
			foreach $ff (keys %{$FilteredND[$newsnum]}) {
				${$ff} = $FilteredND[$newsnum]->{$ff};
			}
			$newsdate = &GetTheDate($newstime);
			@stattext = split( /<pr>/i, $newstext );
			@stattitle = ( $newssubject );
			$stattitle = $newssubject;
			for( my $i = 1; $i < @stattext; ++$i ) {
				if( $stattext[$i] =~ s~\A(.*)</pr>~~i ) {
					$stattitle = $1;
				}
				push( @stattitle, $stattitle );
			}
			$statmax = scalar @stattext;
			@statfile = ( &NCMakeFName );
			$filebase = &NCMakePartialFName;
			for( $_ = 2; $_ <= @stattext; $_++ ) {
				$statfile[$_-1] = "$filebase$_.$filext";
			}
			
			for( $statnum = 0; $statnum < $statmax; $statnum++ ) {
				$newstext = $stattext[$statnum];
				$FileName = $statfile[$statnum];
				$statsubs = $statsubs[$statnum] || $statsubs[$#statsubs];
				$stattmpl = $stattmpl[$statnum] || $stattmpl[$#stattmpl];
				$stattitle = $stattitle[$statnum] || $stattitle[$#statnum];
				$filenum = $statnum + 1;
				$prevhref = $statnum ? $statfile[$statnum-1] : '';
				$nexthref = $statnum < $statmax ? $statfile[$filenum] : '';
				&{$statsubs};
				NPopen(NCFILE, ">$prof->[9]/$FileName");
				if( $stattmpl ) {
					print NCFILE ProcessTMPL("$NPConfig{'admin_path'}/$stattmpl",$newshtml,$newssubject);
				}
				else {
					print NCFILE $newshtml;
				}
				close(NCFILE);
			}
			$FilePrev = $FileName;
			$newsnum--;
		}
	}
	elsif( $prof->[12] eq 'static' ) {
		while ($newsnum >= 0) {
			$NewsCounter++;
			if( $newsnum ) {
				${$prof->[13]} = $FilteredND[$newsnum-1]->{$ff};
				$newsid = $FilteredND[$newsnum-1]->{'newsid'};
				$FileNext = &NCMakeFName;
			}
			else {
				$FileNext = '';
			}
			foreach $ff (keys %{$FilteredND[$newsnum]}) {
				${$ff} = $FilteredND[$newsnum]->{$ff};
			}
			$newsdate = &GetTheDate($newstime);
			$FileName = &NCMakeFName;
			&{$prof->[5]};
			$content .= $newshtml;
			NPopen(NCFILE, ">$prof->[9]/$FileName");
			if( $prof->[6] ) {
				print NCFILE ProcessTMPL("$NPConfig{'admin_path'}/$prof->[6]",$newshtml,$newssubject);
			}
			else {
				print NCFILE $newshtml;
			}
			close(NCFILE);
			$FilePrev = $FileName;
			$newsnum--;
		}
	}
	elsif( $prof->[12] =~ /slindex/ ) {
		my %dedupe;
		for( $newsnum = $#FilteredND; $newsnum >= 0; $newsnum-- ) {
			++$NewsCounter;
			foreach $ff (keys %{$FilteredND[$newsnum]}) {
				${$ff} = $FilteredND[$newsnum]->{$ff};
			}
			$newsdate = &GetTheDate($newstime);
			&NCBuildFields;
			$dedupe{${$prof->[13]}} = 1;
		}
		$NewsCounter = 0;
		$FileName = $prof->[1];
		if ($prof->[6]) {
			if ($FileName =~ /(.+)\./) {
				$FileName = $1;
			} else {
				$FileName = $prof->[1];
			}
			$FileName .= ".$filext";
		}
		$SliceField = $prof->[13];
		$content = '';
		my @dedupe;
		if( $prof->[12] eq 'slindexnumeric' ) {
			@dedupe = sort { $a <=> $b } keys %dedupe;
		}
		else {
			@dedupe = sort { $a cmp $b } keys %dedupe;
		}
		for( $newsnum = $#dedupe; $newsnum >= 0; $newsnum-- ) {
			++$NewsCounter;
			$LinkText = $dedupe[$newsnum];
			${$prof->[13]} = $LinkText;
			$LinkURL = &NCGetFName( $prof->[13] );
			&{$prof->[5]};
			$content .= $newshtml;
		}
		# News built. Now open the text file.
		NPopen(NCFILE, ">$prof->[9]/$prof->[1]");
		print NCFILE $content;
		close(NCFILE);
		# Done. Now generate HTML.
		if ($prof->[6]) {
			NPopen(NCFILE, ">$prof->[9]/$FileName");
			print NCFILE ProcessTMPL("$NPConfig{'admin_path'}/$prof->[6]",$content,$prof->[7]);
			close(NCFILE);
		}
	}
	elsif( $prof->[12] eq 'sliced' ) {
		$FileName = '';
		$SliceField = $prof->[13];
		%ncfiles = ();
		for( $newsnum = $#FilteredND; $newsnum >= 0; $newsnum-- ) {
			++$NewsCounter;
			foreach $ff (keys %{$FilteredND[$newsnum]}) {
				${$ff} = $FilteredND[$newsnum]->{$ff};
			}
			$newsdate = &GetTheDate($newstime);
			&NCBuildFields;
			$SliceValue = ${$SliceField};
			$FileName = &NCGetFName($SliceField);
			&{$prof->[5]};
			if( $FileName ) {
				if( exists $ncfiles{"$FileName"} ) {
					NPopen(NCFILE, ">>$prof->[9]/$FileName");
				}
				else {
					$ncfiles{"$FileName"} = [ $prof->[6], $prof->[7], $SliceValue ];
					NPopen(NCFILE, ">$prof->[9]/$FileName");
				}
				print NCFILE $newshtml;
				close(NCFILE);
			}
		}
		if( $prof->[6] ) {
			foreach $FileName (keys %ncfiles) {
				if( $FileName ) {
					( $nctmplfile, $nchtmltitle, $SliceValue ) = @{$ncfiles{$FileName}};
					NPopen(NCFILE, "$prof->[9]/$FileName");
					{ local $/; $newshtml = <NCFILE>; }
					close(NCFILE);
					NPopen(NCFILE, ">$prof->[9]/$FileName");
					print NCFILE ProcessTMPL("$NPConfig{'admin_path'}/$nctmplfile",$newshtml,"$nchtmltitle$SliceValue");
					close(NCFILE);
				}
			}
		}
	}
	else {
		$FileName = $prof->[1];
		if ($prof->[6]) {
			if ($FileName =~ /(.+)\./) {
				$FileName = $1;
			} else {
				$FileName = $prof->[1];
			}
			$FileName .= ".$filext";
		}
		while ($newsnum >= 0) {
			++$NewsCounter;
			foreach $ff (keys %{$FilteredND[$newsnum]}) {
				${$ff} = $FilteredND[$newsnum]->{$ff};
			}
			$newsdate = &GetTheDate($newstime);
			$LinkURL = &NCMakeFName;
			&{$prof->[5]};
			if ($prof->[10]) {$content .= qq~<a name="newsitem$newsid"></a>~;}
			$content .= $newshtml;
			$newsnum--;
		}
		# News built. Now open the text file.
		NPopen(NCFILE, ">$prof->[9]/$prof->[1]");
		print NCFILE $content;
		close(NCFILE);
		# Done. Now generate HTML.
		if ($prof->[6]) {
			NPopen(NCFILE, ">$prof->[9]/$FileName");
			print NCFILE ProcessTMPL("$NPConfig{'admin_path'}/$prof->[6]",$content,$prof->[7]);
			close(NCFILE);
		}
	}
}

sub NewsCatSubForm {
	push(@formfields, 'newscat');
	my @NCats = split(/\|x\|/, $NPConfig{'NewsCategories'});
	$FormFieldsCustom{'newscat'} = q~<select name="newscat">
	<option value="" selected>(default)</option>~;
	my $ncat;
	foreach $ncat (sort @NCats) {
		$FormFieldsCustom{'newscat'} .= qq~
		<option value="$ncat">$ncat</option>~;
	}
	$FormFieldsCustom{'newscat'} .= q~
	</select>~;
}

sub NewsCatSaveProf {
	my $prof = $in{'editprofsave'};
	
	$in{'statictmpls'} =~ s~\A[\n\s]+~~;
	$in{'statictmpls'} =~ s~[\n\s]+\Z~~;
	$in{'statictmpls'} =~ s~[\n\s]+~\n~g;
	$in{'statictmpls'} =~ s~\n~;~g;
	
	$in{'staticsubs'} =~ s~\A[\n\s]+~~;
	$in{'staticsubs'} =~ s~[\n\s]+\Z~~;
	$in{'staticsubs'} =~ s~[\n\s]+~\n~g;
	$in{'staticsubs'} =~ s~\n~;~g;
	
	@{$newsprofiles{$prof}} = ($newsprofiles{$prof}->[0], $in{'textfile'}, join('!', split(/\|x\|/, $in{'newscategories'})),
	$in{'maxage'}, $in{'maxnum'}, $in{'newssub'}, $in{'tmplfile'}, $in{'tmpltitle'}, $in{'filtsub'}, $in{'filepath'},
	$in{'anchors'}, $in{'skipnum'}, $in{'staticopt'}, $in{'staticname'}, $in{'statictmpls'}, $in{'staticsubs'}, $in{'autobuildstatic'},
	$in{'baseURL'}, $in{'filext'}, $in{'minage'}, $in{'thisURL'} );
	&NewsCatSaveConfig;
}

sub NewsCatEditProf {
	my( %selectedcats, %staticoption, $catselect, %displayanchors, %staticfield, $staticselect, $i, %autorebuildstatic, $tmpl_textarea, $subs_textarea );
	my $prof = $in{'profname'};
	my @prof = @{$newsprofiles{$prof}};
	$prof[3] ||= 0;
	$prof[4] ||= 0;
	$prof[10] ||= 0;
	$prof[11] ||= 0;
	$prof[16] ||= 0;
	$prof[19] ||= 0;
	foreach ( split(/\!/, $prof[2]) ) {
		$selectedcats{$_} = ' selected';
	}
	
	my $catselectsize = scalar @newscategories < 13 ? 2 + scalar @newscategories : 15;
	foreach( @newscategories ) {
		$catselect .= qq~\t\t<option value="$_"$selectedcats{$_}>$_</option>\n~;
	}
	
	$displayanchors{'yes'} = $prof[10] ? ' selected' : '';
	$displayanchors{'no'} = $prof[10] ? '' : ' selected';
	
	$autorebuildstatic{'yes'} = $prof[16] ? ' selected' : '';
	$autorebuildstatic{'no'} = $prof[16] ? '' : ' selected';
	
	$staticoption{$prof[12]} = ' checked';
	
	&SubmitFormFields;
	push(@formfields, 'newsid', 'newscat', 'newstime', 'newsrand');
	push(@formfields, &NCLoadFields);
	$staticfield{$prof[13]} = ' selected';
	foreach( @formfields ) {
		$i = HTMLescape( $FormFieldsName{$_} );
		$i = $i ? qq~$i &nbsp; &nbsp; --&gt; &nbsp; &nbsp; $_~ : $_;
		$staticselect .= qq~\t\t<option value="$_"$staticfield{$_}>$i</option>\n~;
	}
	my $fieldselectsize = scalar @formfields < 15 ? scalar @formfields : 15;
	$tmpl_textarea = $prof[14];
	$tmpl_textarea =~ s~\A[;\s]+~~;
	$tmpl_textarea =~ s~[;\s]+\Z~~;
	$tmpl_textarea =~ s~[;\s]+~;~g;
	$tmpl_textarea =~ s~;~\n~g;
	
	$subs_textarea = $prof[15];
	$subs_textarea =~ s~\A[;\s]+~~;
	$subs_textarea =~ s~[;\s]+\Z~~;
	$subs_textarea =~ s~[;\s]+~;~g;
	$subs_textarea =~ s~;~\n~g;
	
	&NPHTMLHead("NewsCat ][ : Edit profile $prof");
	print << "EOT";
	<form action="$scripturl?newscat" method="post">
	<input type="hidden" name="editprofsave" value="$prof">
	<center><font size="+2"><a href="$scripturl?newscat/help">NewsCat ][ Help</a></font><br>
	<input type="submit" name="submit" value="Save Profile"><br>
	<h2>News Filtering</h2></center>
	<table width="95%" cellpadding="5" cellspacing="10">
	<tr>
	<td width="55%">
		Include news from these categories:<br>
		<ul>Multiple selections:
		<li>Windows: hold down CTRL</li>
		<li>Macintosh: hold down Option</li>
		<li>UNIX: hold down CTRL</li>
		</ul>
	</td>
	<td width="45%">
		<select name="newscategories" size="$catselectsize" multiple>
		<option value="AllCategories" $selectedcats{'AllCategories'}>(All Categories)</option>
		<option value="(default)" $selectedcats{'(default)'}>(Default Category)</option>
		$catselect		</select>
	</td>
	</tr>
	<tr><td colspan="2"><hr width="90%" size="5"></td></tr>
	<tr>
	<td width="55%">
		Minimum age, in days, of news to include:<br>
		Enter a large negative number, such as -10000, to disable.<br><br>
		This is a new feature which is supported only if you leave the filtering subroutine blank or use an updated filtering subroutine. Older filtering subroutines will ignore this value.
	</td>
	<td width="45%">
		<input type="text" name="minage" value="$prof[19]" size="8" maxlength="7">
	</td>
	</tr>
	<tr><td colspan="2"><hr width="90%" size="5"></td></tr>
	<tr>
	<td width="55%">
		Maximum age, in days, of news to include:<br>
		Enter a large number such as <b>10000</b> to disable.
	</td>
	<td width="45%">
		<input type="text" name="maxage" value="$prof[3]" size="8" maxlength="7">
	</td>
	</tr>
	<tr><td colspan="2"><hr width="90%" size="5"></td></tr>
	<tr>
	<td width="55%">
		Maximum number of news to include:<br>
		Enter a large number such as <b>10000</b> to disable.
	</td>
	<td width="45%">
		<input type="text" name="maxnum" value="$prof[4]" size="8" maxlength="7">
	</td>
	</tr>
	<tr><td colspan="2"><hr width="90%" size="5"></td></tr>
	<tr>
	<td width="55%">
		Skip this many news items at beginning:<br>
		Enter 0 (zero) to disable.
	</td>
	<td width="45%">
		<input type="text" name="skipnum" value="$prof[11]" size="8" maxlength="7">
	</td>
	</tr>
	<tr><td colspan="2"><hr width="90%" size="5"></td></tr>
	<tr>
	<td width="55%">
		Filtering subroutine <b>(expert users only)</b><br>
		Leave this blank unless you know what you're doing.
	</td>
	<td width="45%">
		<input type="text" name="filtsub" value="$prof[8]" size="20">
	</td>
	<tr><td colspan="2"><hr width="90%" size="5"></td></tr>
	</tr>
	</table>
	<center><h2>News Display</h2></center>
	<table width="95%" cellpadding="5" cellspacing="10">
	<tr>
	<td width="55%">
		News Generating Subroutine<br>
		<ul>default choices:
		<li>DoNewsHTML: general news style</li>
		<li>DoHeadlineHTML: headline style</li>
		</ul>
	</td>
	<td width="45%">
		<input type="text" name="newssub" value="$prof[5]" size="20">
	</td>
	</tr>
	<tr><td colspan="2"><hr width="90%" size="5"></td></tr>
	<tr>
	<td width="55%">
		Create anchors with news?
		<br><br>
		Unless you're going to be including two or more profiles in the same HTML page, you should leave this on.
	</td>
	<td width="45%">
		<select name="anchors">
			<option value="1"$displayanchors{'yes'}>Yes</option>
			<option value="0"$displayanchors{'no'}>No</option>
		</select>
	</td>
	</tr>
	<tr><td colspan="2"><hr width="90%" size="5"></td></tr>
	<tr>
	<td width="55%">
		Text file to create:
		<br><br>
		Please type here the name of the text file which should be created. This will contain only the formatted news, and will not be appropriate for viewing by itself. It is best to include this file in an SHTML page using SSI, or to encapsulate it in an HTML file using the template options below...
	</td>
	<td width="45%">
		<input type="text" name="textfile" value="$prof[1]" size="20">
	</td>
	</tr>
	<tr><td colspan="2"><hr width="90%" size="5"></td></tr>
	<tr>
	<td width="55%">
		File Location:
		<br><br>
		Please type the full file path to the directory in which the news file should be saved. use forward-slashes (/), even on Windows. Don't include a trailing slash.
	</td>
	<td width="45%">&nbsp;</td>
	</tr>
	<tr>
	<td colspan="2">
		<input type="text" name="filepath" value="$prof[9]" size="60">
	</td>
	</tr>
	<tr><td colspan="2"><hr width="90%" size="5"></td></tr>
	<tr>
	<td width="55%">
		Base URL:
		<br><br>
		Please type the full URL to either the HTTP directory in which the file can be found, or, if the file is to be an index file of links, type the full URL to the HTTP directory containing the files to which it links. This value will be available to you in your news display subroutine as \$baseURL. It is here for your convenience only and does not affect the execution of the script in any way.
	</td>
	<td width="45%">&nbsp;</td>
	</tr>
	<tr>
	<td colspan="2">
		<input type="text" name="baseURL" value="$prof[17]" size="60">
	</td>
	</tr>
	<tr>
	<td width="55%">
		This URL:
		<br><br>
		Please type the full URL to the HTTP directory in which the file can be found. This value will be available to you in your news display subroutine as \$thisURL. This value is different from the \$baseURL property, and it is important.
	</td>
	<td width="45%">&nbsp;</td>
	</tr>
	<tr>
	<td colspan="2">
		<input type="text" name="thisURL" value="$prof[20]" size="60">
	</td>
	</tr>
	<tr><td colspan="2"><hr width="90%" size="5"></td></tr>
	</table>
	<center><h2>Template Usage</h2></center>
	<table width="95%" cellpadding="5" cellspacing="10">
	<tr>
	<td width="55%">
		Template file to use, or blank if none:<br>
		A template file is used to wrap an HTML page around
		the news text, giving it a nice format. This can be
		used in place of SSI if you wish, to generate a complete
		HTML file.
		<br><br>
		The template file may have any extension you wish. The only
		requirement is that it have two special tags: &lt;InsertTitle&gt;
		and &lt;InsertContent&gt;.
		<br><br>
		(template must reside in the NewsPro source directory)
	</td>
	<td width="45%">
		<input type="text" name="tmplfile" value="$prof[6]" size="20">
	</td>
	</tr>
	<tr><td colspan="2"><hr width="90%" size="5"></td></tr>
	<tr>
	<td width="55%">
		Template Title:
		If using template, specify a nice title.
		<br><br>
		This title will be inserted where the text &lt;InsertTitle&gt; is found everywhere in the template used.
	</td>
	<td width="45%">
		<input type="text" name="tmpltitle" value="$prof[7]" size="20">
	</td>
	</tr>
	<tr><td colspan="2"><hr width="90%" size="5"></td></tr>
	<tr>
	<td width="55%">
		File Extension:
		If using template, specify a file extension to use for the generated HTML file.<br>
		<br><br>
		If only a single file is being generated (ie: normal profile) then the name of the generated file will be the <b>text file name</b> specified above (currently, '$prof[1]'), with the file extension replaced.
		<br><br>
		If multiple files are being generated by this profile, then this file extension will be used for each of the different files created. The file names will be determined based on the static field you choose. That static field can be selected below, in the <b>Profile Type</b> section.
	</td>
	<td width="45%">
		<input type="text" name="filext" value="$prof[18]" size="8">
	</td>
	</tr>
	<tr><td colspan="2"><hr width="90%" size="5"></td></tr>
	</table>
	<center><h2>Profile Types</h2></center>
	<br>
	<blockquote><i>Here you may configure your profile for advanced options, such as creating a separate file for each news item, or grouping all news items with a differing value in the 'static field' into separate files, or archiving by date or number.</i></blockquote>
	<table width="95%" cellpadding="5" cellspacing="10">
	<tr>
	<td colspan="2">
		<input type="radio" name="staticopt" value=""$staticoption{''}><font size="+1">Normal Profile</font>
		<br>
		Build All news to a single file.
		<br><br>
		<input type="radio" name="staticopt" value="static"$staticoption{'static'}><font size="+1">Standard Static Pages</font>
		<br>
		Build each news item to its own file. It is recommended that you use a template if you choose this option.<br>
		<br><br>
		<input type="radio" name="staticopt" value="split"$staticoption{'split'}><font size="+1">Split Static Pages</font>
		<br>
		Build each news item to its own file. If &lt;PR&gt; tags exist in the news text, split the news item between several files based on the &lt;PR&gt; tags. If you use <i>&lt;PR&gt;TITLE&lt;/PR&gt;</i> instead, the following page will have a title specified by the text in between the opening and closing PR tags.
		<br><br>
		<input type="radio" name="staticopt" value="sliced"$staticoption{'sliced'}><font size="+1">"Sliced" Pages</font>
		<br>
		All variables with the same value in the static field will be placed in the same file. For example, choosing 'newssubject' as the static field and 'Sliced' as the profile type, you might then obtain two files: 'importantinformation.html' containing all news items which have the subject 'Important Information', and 'funnystuff.html' containing all news items which have the subject 'Funny Stuff.'
		<br><br>
		<input type="radio" name="staticopt" value="slindex"$staticoption{'slindex'}><font size="+1">Alphabetic Sliced Page Index</font>
		<br>
		A profile of this type is meant to serve as an index file for another profile, with identical configuration, of type "Sliced." So, the other profile would generate the files such as 'importantinformation.html' and 'funnystuff.html', and the Sliced Page Index would then list links to those files, in alphabetical order. Due to the limited and specialized nature of this profile, it really only has two useful variables: <b>\$LinkText</b> and <b>\$LinkURL</b>. \$LinkText would be 'Important Information' and 'Funny Stuff', and \$LinkURL would be 'importantinformation.html' and 'funnystuff.html.' In this way you can build up a simple link list to all the files created by a Sliced profile.
		<br><br>
		<input type="radio" name="staticopt" value="slindexnumeric"$staticoption{'slindexnumeric'}><font size="+1">Numeric Sliced Page Index</font>
		<br>
		A profile of this type is meant to serve as an index file for another profile, with identical configuration, of type "Sliced." It is exactly the same as the above type, 'Alphabetic Sliced Page Index', except that it sorts the static field variables numerically instead of alphabetically. So, for example, in an alphabetically sorted list, '9' would be above '100' because the character '9' is considered greater than the character '1', whereas in a numerically sorted list, the static field values are treated as numbers, and '100' would appear before '9' because it is larger.
	</td>
	</tr>
	<tr><td colspan="2"><hr width="90%" size="5"></td></tr>
	<tr>
	<td width="55%">
		Static Field:
		<br><br>
		This is the special field you have heard so much about! It controls how static files are named and how sliced profiles are separated. Basically, you just choose here the field which you wish to use as the determining field for your profile. For example, if you wish for all files to have a unique filename, you would use <b>newsid</b> as the static field.
		<br><br>
		Of course, this wouldn't be a good field to choose for a Sliced Profile, because no two news items would have the same ID and thus they would all be printed to different files. If your profile is of type 'Sliced', you would probably want to use either the <b>newscat</b> or <b>newssubject</b> field for news item separation. Thus, all news items in the Sliced profile from category 'HotNews' would be built to the file 'hotnews.html', and so on.
		<br><br>
		Please note that the choices preceded with an asterisk (*) are for use only with <b>Sliced Profiles</b> and <b>Sliced Index Profiles</b>. They are not useful with any other type of Profile. Several of these choices are built in to NewsCat ][ to assist you in mimicking the functionality of NewsPro's archival features. They are best used with the <b>minimum age</b> option to archive only specific categories, etc. For example, you could choose 'Sliced Profile' and 'minimum age' == 7 days and '10 news items per page' to mimic NewsPro's archive by number feature, available in Advanced Settings.
	</td>
	<td width="45%">
		<select name="staticname" size="$fieldselectsize" style="width:100%">
		$staticselect		</select>
	</td>
	</tr>
	<tr><td colspan="2"><hr width="90%" size="5"></td></tr>
	<tr>
	<td width="55%">
		Auto-Rebuild Static / Split Static Pages?
		<br><br>
		If you choose this option, <b>and</b> if this profile is a Static or Split-Static profile, then the files generated by this profile will only be rebuilt when you modify the individual news item(s) associated with that file. This is very efficient and can save you a lot of time in 'Build News.' The only way to completely rebuild all the files at once is to click 'NewsCat ][ Total Rebuild' in the NewsPro functions bar. You would only want to do this if you deleted the generated HTML files, or changed the template or news subroutine used to generate the files.
	</td>
	<td width="45%">
		<select name="autobuildstatic">
		<option value="1"$autorebuildstatic{'yes'}>Yes</option>
		<option value="0"$autorebuildstatic{'no'}>No</option>
		</select>
	</td>
	</tr>
	<tr><td colspan="2"><hr width="90%" size="5"></td></tr>
	<tr>
	<td width="55%">
	Split Static Page Templates:
	<br><br>
	If your Profile Type is set to "Split Static" then you may specify additional templates to use in this text box, one per line. The first page will use the normal template for this Profile, and each additional page will use, in order, the templates named here. If there are more pages than templates listed, the last template listed will be used for the remaining pages.
	</td>
	<td width="45%">
	<textarea name="statictmpls" rows="8" cols="20">$tmpl_textarea</textarea>
	</td>
	</tr>
	<tr><td colspan="2"><hr width="90%" size="5"></td></tr>
	<tr>
	<td width="55%">
	Split Static Page Subroutines:
	<br><br>
	If your Profile Type is set to "Split Static" then you may specify additional subroutines to use in this text box, one per line. The first page will use the normal subroutine for this Profile, and each additional page will use, in order, the subroutines named here. If there are more pages than subroutines listed, the last subroutine listed will be used for the remaining pages.
	</td>
	<td width="45%">
	<textarea name="staticsubs" rows="8" cols="20">$subs_textarea</textarea>
	</td>
	</tr>
	<tr><td colspan="2"><hr width="90%" size="5"></td></tr>
	</table>
	<center><input type="submit" name="submit" value="Save Profile"><br>
	<font size="+2"><a href="$scripturl?newscat/help">NewsCat ][ Help</a></font></center>
	</form>
EOT
	&NPHTMLFoot;
}

sub NewsCatLoadConfig {
	@newscategories = sort(split(/\|x\|/, $NPConfig{'NewsCategories'}));
	@nprof = split(/\|x\|/, $NPConfig{'NewsProfiles'});
	for( my $i = 0; $i < @nprof; $i++ ) {
		@nprof2 = split(/\~/, $nprof[$i]);
		my $j = shift(@nprof2);
		if ($j) {
			$nprof[$i] = $j;
			my $FileName;
			if ($nprof2->[1] =~ /(.+)\./) {
				$FileName = $1;
			} else {
				$FileName = $nprof2->[1];
			}
			$FileName .= ".$NPConfig{'ArcHtmlExt'}";
			$newsprofhtml{$j} = $FileName;
			$newsprofiles{$j} = [];
			@{$newsprofiles{$j}} = @nprof2;
		}
	}
}

sub NewsCatSaveConfig {
	$NPConfig{'NewsCategories'} = join('|x|', @newscategories);
	my @nprof = ('');
	foreach $i (sort keys %newsprofiles) {
		push(@nprof, join('~', $i, @{$newsprofiles{$i}}));
	}
	$NPConfig{'NewsProfiles'} = join('|x|', @nprof);
	&WriteConfigInfo;
}

sub NewsCatMain {
	unless ($UserPermissions{$Cookies{'uname'}} == 3) {
		&NPdie('You are not authorized to access this');
	}
	&NewsCatLoadConfig;
	if ($in{'editprof'} && $newsprofiles{$in{'profname'}}) {
		&NewsCatEditProf;
		exit;
	}
	if ($in{'editprofsave'}) {
		&NewsCatSaveProf;
	}
	if ($in{'removecat'}) {
		my @new_newscategories;
		foreach $i (@newscategories) {
			unless ($i eq $in{'removecat'}) {
				push(@new_newscategories, $i);
			}
		}
		@newscategories = @new_newscategories;
		&NewsCatSaveConfig;
	}
	if ($in{'removeprof'}) {
		if ($newsprofiles{$in{'profname'}}) {
			delete $newsprofiles{$in{'profname'}};
		}
		&NewsCatSaveConfig;
	}
	if ($in{'addcat'}) {
		$in{'addcat'} =~ s/\W//g;
		if ($in{'addcat'} ne "") {
			push(@newscategories, $in{'addcat'});
		}
		&NewsCatSaveConfig;
	}
	if ($in{'addprof'}) {
		$in{'addprof'} =~ s/\W//g;
		unless ($newsprofiles{$in{'addprof'}} || $in{'addprof'} eq "") {
			$newsprofiles{$in{'addprof'}} = ['0', "$in{'addprof'}.txt", 'AllCategories', '10000', '100000', 'DoNewsHTML', '', '', '', $NPConfig{'htmlfile_path'},'0','0','','newssubject','','','1','','html','-10000',''];
		}
		&NewsCatSaveConfig;
	}
	if ($in{'savecheck'}) {
		foreach $i (keys %newsprofiles) {
			$newsprofiles{$i}->[0] = $in{"cc--$i"};
		}
		&NewsCatSaveConfig;
	}
	&NPHTMLHead("News Categories ][");
	print q~
	<div align="center"><h3>News Categories ][</h3><table width="80%" border="0">
	~;
	foreach $i (@newscategories) {
		print qq~
		<tr> 
		<td>$i</td>
		<td> <div align="center"> <form action="$scripturl?newscat" method="POST">
		<input type="hidden" name="removecat" value="$i">
		<input type="submit" name="Submit" value="Remove"></form>
		</div> </td> </tr>
		~;
	}
	print qq~
</table>
<b>Add new category:</b><form action="$scripturl?newscat" method="POST">
<input type="text" name="addcat" value="Name"><input type="submit" name="submit" value="Submit">
</form><hr width="75%">
	~;
	print qq~
	<h3>News Profiles ][</h3><table width="80%" border="1" cellpadding="10">
	<form action="$scripturl?newscat" method="POST">
	<tr><td valign="middle" align="center"><font size="+1">Profile Name</font></td>
	<td valign="middle" align="center" width="100">File Creation</td>
	<td valign="middle" align="center" width="150"><div align="center">Enabled / Disabled</div></td></tr>
	~;
	my( $yescheck, $noncheck );
	my @prof = sort keys %newsprofiles;
	my $psize = scalar @prof;
	foreach $i (@prof) {
		$yescheck = $newsprofiles{$i}->[0] ? ' checked' : '';
		$noncheck = $newsprofiles{$i}->[0] ? '' : ' checked';
		print qq~<tr><td valign="middle">$i</td><td width="100" align="center">~;
		print ( $newsprofiles{$i}->[0] ? q~<b>enabled</b>~ : q~<i>disabled</i>~ );
		print qq~</td><td align="center" width="150">
		<input type="radio" name="cc--$i" value="1"$yescheck> / <input type="radio" name="cc--$i" value="0"$noncheck>
		</td></tr>~;
	}
	$psize++;
	print qq~
	<tr><td colspan="9" valign="middle"><div align="center">
	<input type="submit" name="savecheck" value="Save Enable States">
	</div></td></tr></form>
	</table><br><br>
	<table width="80%" border="1" cellpadding="10" cellspacing="10"><tr><td align="left">
	<form action="$scripturl?newscat" method="POST">
	<input type="submit" name="removeprof" value="Delete Selected Profile"></td></tr><tr><td align="middle">
	<select name="profname" size="$psize"><option value="" selected>(none selected)</option>~;
	foreach $i (@prof) {
		print qq~<option value="$i">$i</option>~;
	}
	print q~</select></td></tr><tr><td align="right">
	<input type="submit" name="editprof" value="Edit Selected Profile">
	</td></tr></form></table>~;
	print qq~
	<b>Add new profile:</b><form action="$scripturl?newscat" method="POST">
	<input type="text" name="addprof" value="Name"><br><input type="submit" name="submit" value="Submit">
	</form><br>
	<div align="center"><font size="+2"><a href="$scripturl?newscat/help">NewsCat ][ Help</a></font></div>
	~;
	&NPHTMLFoot;
}

sub NewsCatPageHandler {
	if ($qstring eq 'newscat') {
		&NewsCatMain;
		exit;
	}
	elsif ($qstring eq 'newscattotalrebuild') {
		&NPHTMLHead('All Enabled Profiles ReBuilt');
		print q~All currently enabled news profiles have been totally rebuilt.~;
		&NewsCatTotalReBuild;
		&NPHTMLFoot;
		exit;
	}
	elsif($qstring eq 'newscat/help' || $qstring eq 'helpnewscat') {
		&NPHTMLHead('NewsCat ][ Help');
		print q^<div align="center"><h2>NewsCat ][<br>by <a href="mailto:plushpuffin@wwddfd.com">plushpuffin</a></h2>
<h4>NewsCat ][ is an enhancement/upgrade to the normal News Categories addon.<br>
It is intended as a replacement, which means that you must remove npa_category.pl and npa_category_rufus.pl</h4></div>
<hr>
<ul><h4>NewsCat ][ adds the following features:</h4>
<li>skip X news items before generating news.</li>
<li>minimum news age</li>
<li>file extension choice.</li>
<li>base URL property.</li>
<li>static pages.</li>
<li>split static pages.</li>
<li>auto-rebuilding of static pages.</li>
<li>sliced pages: new in build 8</i>
</ul>
<hr>
<ul><h4>minimum news age</h4>
<li>allows you to specify the minimum allowable age for a news item.</li>
<li>useful for creating category-based archives.</li>
</ul>
<hr>
<ul><h4>skip X newsitems</h4>
<li>allows you to skip the first 5 news items.</li>
<li>can be pretty cool if you create one profile which shows only the first 5 newsitems, and another which shows newsitems 6 to 100 (ie skipping the first 5).</li>
</ul>
<hr>
<ul><h4>file extension choice</h4>
<li>allows you to choose what file extension you want when using templates to create HTML files (or other files).</li>
<li>default is "html" - if the file extension field is blank, the archive extension (found in NewsPro's settings) is used instead.</li>
</ul>
<a name="baseURL"></a>
<hr>
<ul><h4>baseURL property</h4>
<li>provided for your convenience.</li>
<li>allows you to easily use a specific base URL path for a profile.</li>
<li>very helpful when creating an index file linking to static pages.</li>
</ul>
<a name="thisURL"></a>
<hr>
<ul><h4>thisURL property</h4>
<li>required for the comments system to work properly.</li>
<li>this field must represent the HTTP directory URL to the folder in which this profile's files will be saved.</li>
</ul>
<a name="static"></a>
<hr>
<ul><h4>linking to static pages</h4>
<li>create a static page profile if you haven't already.</li>
<li>create a new profile to use as the index profile.</li>
<li>set up the index profile to include the same newsitems as the static profile.</li>
<li>choose "normal - no static" for the index profile.</li>
<li>choose the same "filename field" for the index profile that you are using for the static profile...<br>
this is probably either $newssubject or $newsid.</li>
<li>make sure that the index profile has the same file extension as the static profile.</li>
<li>fill in the baseURL field to the base URL of the static pages directory.<br>
eg - if static files are at <b>http://www.mysite.com/folder/staticpages</b> then enter <b>http://www.mysite.com/folder</b> for the baseURL.</li>
<li>If you wish, you may use a partial URL, such as <b>folder</b> (if the index file is at <b>http://www.mysite.com/index.html</b> and the static files are at <b>http://www.mysite.com/folder/staticpages</b>).</li>
</ul>
<ul><h4>linking to static pages: news generating subroutine</h4>
<li>you may type in <b>staticlinks</b> for the news generating subroutine for your index profile, or make your own subroutine.</li>
<li>the subroutine staticlinks is listed below for your convenience.
<ul><pre><code>sub staticlinks {
	$newshtml = qq~~;
	$fname = &amp;NCMakeFName;
	$newshtml .= qq~&lt;a href=&quot;$baseURL/$fname&quot;&gt;$newssubject&lt;/a&gt;&lt;BR&gt;~;
}</code></pre></ul>
</li>
</ul>
<hr>
<ul><h4>making your own <b>staticlinks</b>-like subroutine</h4>
<li>open ndisplay.pl and at the bottom of the file (just above the line "1;") put the following code.
<ul><pre><code>sub MyStaticLinks {
	$newshtml = qq~~;
	$fname = &amp;NCMakeFName;
	$newshtml .= qq~&lt;a href=&quot;$baseURL/$fname&quot;&gt;$newssubject&lt;/a&gt;&lt;BR&gt;~;
}</code></pre></ul>
</li>
<li>Now, edit the subroutine as you please.</li>
<li>The following functions may be useful to you.
<ul>
	<li>&amp;NCMakeFName</li>
	<li>&amp;NCMakePartialFName</li>
	<li>&amp;NCGetFName( 'fieldname' )</li>
</ul>
</li>
<li>&amp;NCMakeFName generates a nice filename for the current news item (using the field selected in Edit Profile).</li>
<li>&amp;NCMakePartialFName generates the same filename, but without the file type extension at the end.</li>
<li>&amp;NCGetFName( 'newssubject' ) returns a nice filename for the current news item using the field whose name you specify (in this case, $newssubject).</li>
</ul>
<a name="split"></a>
<hr>
<ul><h4><b>split static pages</b></h4>
	<li>split static pages means that each newsitem will appear on a separate page, and each newsitem will be split into several files.</li>
	<li>the file splitting occurs wherever you insert a &lt;PR&gt; tag in your news text. The news text will be split into however many pages you want...
	<li>Put the tag &lt;PR&gt; (uppercase or lowercase - it doesn't matter) in your news text.<BR>Your news will be split at the exact locations of these tags into several files.</li>
	<li>you can refer to the previous and next page in your DoNews subroutine with $prevhref and $nexthref.<BR>
	$prevhref will be blank on the first page, and $nexthref will be blank on the last page.</li>
	<li>The current file name can be accessed using the variable $FileName.</li>
	<ul><b>file splitting examples:</b>
		<li>If there are five &lt;PR&gt; tags, then your newsitem will be split into six files.</li>
		<li>If there is just one &lt;PR&gt; tag, then the newsitem will be split into two pages.</li>
		<li>With no &lt;PR&gt; tags, the newsitem will appear all on one page, which would make it identical to a normal static page.</li>
	</ul></li>
	<li>New in build 12 of NewsCat ][: if you have &lt;pr&gt;TITLE HERE&lt;/pr&gt; instead of just a &lt;pr&gt; tag, the 'TITLE HERE' part can be used as the title for the page following the &lt;PR&gt; tag, through the $stattitle variable.</li>
</ul>
<a name="sliced"></a>
<hr>
<ul><h4><b>sliced pages</b>: new in build 8</h4>
	<li>the sliced pages feature allows you to separate news items into different files based on the value of a certain news field, known as the &quot;slice field.&quot;
	<ul><b>eg:</b>
	<li>choose <code>sliced static pages</code> for the static page option.</li>
	<li>choose <code>newssubject</code> as the slice field.</li>
	<li>newsdat.txt contains 5 newsitems:
		<ol><code><b>Subject : Date</b></code>
		<li>News Flash : Feb 07, 2000</li>
		<li>Sports News : May 15, 2000</li>
		<li>News Flash : Jun 17, 2000</li>
		<li>Sports News : Aug 21, 2000</li>
		<li>News Flash : Oct 28, 2000</li>
		</ol>
	</li>
	<li>Two files will be generated: NewsFlash.html and SportsNews.html
		<ul><code>NewsFlash.html</code>
		<li>News Flash : Feb 07, 2000</li>
		<li>News Flash : Jun 17, 2000</li>
		<li>News Flash : Oct 28,2000</li>
		</ul>
		<ul><code>SportsNews.html</code>
		<li>Sports News : May 15, 2000</li>
		<li>Sports News : Aug 21, 2000</li>
		</ul>
	</li>
	</ul>
	</li>
</ul>
<ul><h4><b>sliced pages fake fields</b></h4>
<li>these "fake fields" allow you to make sliced pages with the format "August-2000.html"</li>
<li>Great workaround for archiving by category, etc</li>
<li>open <code>npa_newscat2.pl</code> in a text editor</li>
<li>follow the directions at the top of the two subroutines:
	<ul>
	<li>NCBuildFields(): Define what the fields contain</li>
	<li>NCLoadFields(): Declare the fields so they show up as choices</li>
	</ul>
</li>
</ul>
<ul><h4><b>slice index subroutine</b></h4>
<li>a slice index subroutine is included at the top of the npa_newscat2.pl</li>
<li>use the variables listed below which are available to you for the Slice Index</li>
</ul>
<hr>
<ul><h2>Variables</h2><ul>
<ul><h4><b>Universal Variables</b></h4>
<li>$NewsCounter : the number of the current newsitem.</li>
<li>$filext : the file extension used by the current profile.</li>
<li>$baseURL : the base URL used by the current profile.</li>
<li>$thisURL : the URL of the directory in which the current file will be created.</li>
<li>$FileName : name of the current file being written.</li>
</ul>
<hr>
<ul><h4><b>Static &amp; Split Static Variables</b></h4>
<li>$FileFirst : name of first file in the current profile.</li>
<li>$FilePrev : name of previous file in the current profile.</li>
<li>$FileNext : name of next file in the current profile.</li>
<li>$FileLast : name of last file in the current profile.</li>
</ul>
<hr>
<ul><h4><b>Split Static (only) Variables</b></h4>
<li>@statsubs : array of all the static subroutines (per-page)</li>
<li>@stattmpl : array of all the static templates (per-page)</li>
<li>@stattext : array of all the static news texts (per-page)</li>
<li>@stattitle : array of all the titles specified for the pages. See $stattitle, below, for more info.</li>
<li>$stattitle : title for the current page, as specified by inclusion of a closing &lt;/pr&gt; tag, before which you should put the title.<br>
	example: &lt;pr&gt;<i>TITLE OF THE FOLLOWING PAGE</i>&lt;/pr&gt;<br>
	if you only use the single &lt;pr&gt; tag with no closing tag, then the $stattitle variable will use the last specified title,
	or the $newssubject if no split pages for the current news item have any titles specified.</li>
<li>$statmax : the maximum number of split pages for this newsitem</li>
<li>$statnum : the number of the current page (starts at zero)</li>
<li>$filenum : the number of the current page (starts at one)</li>
<li>$filebase : the base part of the filename for this newsitem, without the number or extension<br>
the real filename for the current page is $FileName, which is equal to "$filebase.$filext" for the first page, and "$filebase$filenum.$filext" for all subsequent pages</li>
<li>$prevhref : the name of the previous page for this newsitem</li>
<li>$nexthref : the name of the next page for this newsitem</li>
</ul>
<hr>
<ul><h4><b>Slice Index &amp; Sliced Variables</b></h4>
<li>$SliceField : the name of the field used to slice pages</li>
</ul>
<hr>
<ul><h4><b>Slice Index (only) Variables</b></h4>
<li>$LinkText : the value of the slice field</li>
<li>$LinkURL : the name of the sliced page</li>
</ul>
<hr>
<ul><h4><b>Sliced (only) Variables</b></h4>
<li>$SliceValue : the value of the slice field.</li>
</ul>
<hr>
<ul><h4><b>Normal (non-static only) Variables</b></h4>
<li>$LinkURL : the value returned by the function &amp;NCMakeFName, provided for your convenience.</li>
</ul>
</ul></ul>
^;
print qq~
<div align="center"><a href="$scripturl">back to newspro</a><br>
<font size="+1"><a href="$scripturl?newscat">back to NewsCat ][</a></font><br>
<a href="http://www.wwddfd.com">visit plushpuffin's perl garden</a></div>
~;
		&NPHTMLFoot;
		exit;
	}
}

sub NewsCatRemoveNewsSave {
	push(@formfields, 'newscat');
}

sub NewsCatRemoveNews2 {
	my @NCats = split(/\|x\|/, $NPConfig{'NewsCategories'});
	my $nci;
	print qq~ Category:
	<select name="newscat--$newsnum"><option value=""~;
	unless ($newscat) {
		print " selected";
	}
	print ">(default)</option>";
	foreach $nci (@NCats) {
		print qq~
		<option value="$nci"~;
		if ($nci eq $newscat) {
			print " selected";
		}
		print qq~>$nci</option>~;
	}
	print "</select>";
}

sub NewsCat_HTMLFoot {
	if ($up == 3) {
		print qq~ <a href="$scripturl?newscat" class="navlink">NewsCat ][ build $nc2Build</a> | <a href="$scripturl?newscattotalrebuild" class="navlink">NewsCat_][_Total_Rebuild</a> |~;
	}
}

sub NewsCat_MainPage {
	if ($up == 3) {
		print qq~
		<b><a href="$scripturl?newscat">NewsCat ][ build $nc2Build</a>:</b> Configure news categories and profiles, features that allow you to create multiple news files. Enhanced with static pages, split static pages, and sliced pages, by <a href="mailto:plushpuffin\@wwddfd.com">plushpuffin</a> - <a href="http://www.wwddfd.com">perl garden</a><br><br>
		~;
	}
}
1;
